@echo off

REM  This script sets environment variables for Windows systems
REM  and ensures dependancies are installed.

REM SET THE ENVIRONMENT

pushd %0\..\..\ThirdParty\
SET NXJ_HOME=%CD%\lejos_nxj

REM Use the 32-bit, GPL, OpenJDK if it can be found
REM Set ENC_IGNORE_OPENJDK to 1 if you don't want to use the OpenJDK
IF NOT EXIST openjdk goto noopenjdk
IF "%ENC_IGNORE_OPENJDK%"=="" SET JAVA_HOME=%CD%\openjdk
IF "%ENC_IGNORE_OPENJDK%"=="" SET LEJOS_NXT_JAVA_HOME=%JAVA_HOME%
:noopenjdk

popd

pushd %0\..\..\OnDevice\NXT\
SET ENCHANTING_JAR=%CD%\enchanting.jar
popd

REM ENSURE WE CAN FIND DEPENDENCIES

REM Find the JDK
if not "%JAVA_HOME%" == "" goto javaHomeAlreadySet

REM Look in Program Files (x86) on 64-bit systems.
SET PROGFILES=%ProgramFiles(x86)%
if "%PROGFILES%" == "" SET PROGFILES=%ProgramFiles%

for /d %%i in ("%PROGFILES%\Java\jdk*") do set JAVA_HOME=%%i
:javaHomeAlreadySet

REM Find the Fantom driver for the NXT.  (It should be on the path.)
REM set FANTOM_HOME=
for %%i in (NiViUsb.dll) do if NOT "%%~$PATH:i"=="" set FANTOM_HOME=%%~$PATH:i

REM Uncomment these lines to debug the messages to alert users of missing dependencies
REM set JAVA_HOME=
REM set FANTOM_HOME=

echo JAVA_HOME=%JAVA_HOME%
echo FANTOM_HOME=%FANTOM_HOME%

if "%JAVA_HOME%" == "" goto missingDependancies
if "%FANTOM_HOME%" == "" goto missingDependancies

echo Found all dependencies.

SET PATH=%NXJ_HOME%\bin;%JAVA_HOME%\bin;%PATH%

exit /B 0



:missingDependancies

REM Show error message on console
echo Unable to run Enchanting.
if "%JAVA_HOME%" == "" echo - You need to install the Java Developer Kit
if "%FANTOM_HOME%" == "" echo - You need to install the NXT driver
echo Please install the required software and try again.

REM Show error message as pop-up window
Call MissingDependencies.vbs

exit /B 1
