Object subclass: #BlockLabelFragment
	instanceVariableNames: 'label type isInput default isDeleted '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:24'!
default
	^ default! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:24'!
default: aValue
	default _ aValue! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 05:06'!
delete
	isDeleted _ true! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 05:06'!
initialize

	super initialize.
	isDeleted _ false.
	label _ ''.
	isInput _ false.
	type _ #any.
	default _ ''! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 05:06'!
isDeleted
	^ isDeleted! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:23'!
isInput
	^ isInput! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:23'!
isInput: aBool
	isInput _ aBool! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 4/18/2010 23:03'!
isLoop

	isInput ifFalse: [^ false].
	type ifNil: [^ false].
	^ type = #loop! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 00:07'!
isMultipleInput

	isInput ifFalse: [^ false].
	type ifNil: [^ false].
	^ type endsWith: 'List'! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 20:41'!
isTemplate

	isInput ifFalse: [^ false].
	type ifNil: [^ false].
	^ type = #template! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 7/27/2010 01:00'!
isUnevaluated

	isInput ifFalse: [^ false].
	type ifNil: [^ false].
	^ type beginsWith: 'unevaluated'! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:23'!
label
	^label! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 4/27/2010 22:21'!
label: aString

	label _ aString
! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 02:19'!
spec
	| spec |
	isDeleted ifTrue: [^''].
	isInput ifFalse: [^ label].
	label isEmpty ifTrue: [^ label].
	spec _ '%', label asMacRoman. 
	(spec includes: $ ) ifTrue: [
		^ (String with: $"), spec, (String with: $")].
	^spec asUTF8

! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:24'!
type
	^type! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 00:14'!
type: aSymbol
	type _ aSymbol! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 00:15'!
updateLabel

	"make sure an ellipsis (...) is added to the label
	if I am a multiple input type - unused for now"

	(self isMultipleInput and: [
		(label endsWith: '...') not]) ifTrue: [
			label _ label, '...'.
			^ self].

	(label endsWith: '...') ifTrue: [
		label _ label copyFrom: 1 to: label size - 3]! !
