SyntaxElementMorph subclass: #MessageElementMorph
	instanceVariableNames: 'receiver selector arguments labels cascade '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 21:27'!
acceptDroppingMorph: aMorph event: evt

	self addToCascade: aMorph! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:41'!
addLabel
	label _ StringMorph contents: '' font: self labelFont.
	label color: self labelColor.
	self addMorphFront: label.
! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:29'!
addReceiver
	receiver _ ArgumentElementMorph new.
	self addMorphFront: receiver.! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 18:52'!
addToCascade: aMessageElement
	cascade add: aMessageElement.
	self addMorph: aMessageElement.
	aMessageElement embedAsCascade! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 00:26'!
argumentCount
	^arguments size! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 22:42'!
arguments: anArray

	1 to: anArray size do: [:i|
		(arguments size < i) ifFalse: [
			(arguments at: i) contents: (anArray at: i ) ]]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 01:00'!
asSmalltalk
	| ws |
	receiver isHidden ifTrue: [^self keywordsAndArgs ].
	cascade isEmpty not ifTrue: [ ^self cascadeCode ].

	ws _ WriteStream on: String new.
	^ws
		nextPutString: receiver asSmalltalk, ' ';
		nextPutString: self keywordsAndArgs;
		contents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 23:49'!
assign
	self selector: #_ arguments: { ObjectElementMorph new }.
	(arguments at: 1) contents delete. 
	(arguments at: 1) removeContents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:52'!
beBinary
	self binarySelector: selector! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:53'!
binarySelector: aString

	| lb arg |

	selector _ aString.
	label ifNotNil: [label delete. label _ nil].
	labels do: [:each| each delete ].
	arguments do: [:each| each delete ].
	labels _ OrderedCollection new.
	arguments _ OrderedCollection new.

	lb _ ((StringMorph contents: aString font: self labelFont) color: self labelColor).
	labels add: lb.
	self addMorph: lb.
	arg _ ArgumentElementMorph new.
	arguments add: arg.
	self addMorph: arg.
	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 00:42'!
buildLabelsAndArgs

	| tokens lb arg |
	label ifNotNil: [label delete. label _ nil].
	labels do: [:each| each delete ].
	arguments do: [:each| each delete ].
	labels _ OrderedCollection new.
	arguments _ OrderedCollection new.

	((selector includes: $:) not | (selector = ':=')) ifTrue: [
		self label: (self wordsFrom: selector).
		^self ].

	tokens _ selector findTokens: ':'.
	tokens do: [:each| 
		lb _ ((StringMorph contents: (self wordsFrom: each) font: self labelFont) color: self labelColor).
		labels add: lb.
		self addMorph: lb.
		arg _ ArgumentElementMorph new.
		arguments add: arg.
		self addMorph: arg].
		! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 01:10'!
cascadeCode
	| ws |
	ws _ WriteStream on: String new.
	ws nextPutString: receiver asSmalltalk.
	cascade do: [:msg|
		ws cr;
			nextPutString: msg asSmalltalk, ' ';
			nextPut:$; ].
	^ws
		nextPutString: self keywordsAndArgs;
		cr; 
		contents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:02'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	self isRenameable
		ifTrue: [
			m add: 'rename...' action: #editSelector.
			arguments isEmpty ifTrue: [
				m add: 'add argument' action: #beBinary ].
			m addLine ]
		ifFalse: [m addLine ].
	m add: 'show code...' action: #showGeneratedSmalltalk.
	m add: 'show result...' action: #showResult.
	m add: 'evaluate' action: #evaluate.
	^m! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:21'!
editSelector
	|ans|

	ans _ FillInTheBlank request: 'selector:' initialAnswer: selector.
	(ans size > 0) ifTrue: [self selector: ans]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 18:51'!
embedAsCascade
	receiver isHidden: true.
	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 23:30'!
extractFromCascade
	receiver isHidden: false.
	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 21:41'!
fit

	receiver isHidden ifTrue: [^self fitForCascade ].
	cascade isEmpty not ifTrue: [ ^self fitCascaded ].
	self isStacked
	ifTrue: [self fitStacked]
	ifFalse: [self fitInLine]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 22:08'!
fitCascaded
	| cw bw bw2 x y arg lb maxHeight maxRight labelTop labelBottom cntr |
	cw _ self labelFont widthOf: $ .
	bw _ self borderWidth.
	bw2 _ bw * 2.

	x _ receiver right + bw2.
	maxRight _ x.
	y _ self top + bw2.

	cascade do: [:eachElement |
		eachElement position: x @ y.
		maxRight _ maxRight max: eachElement right.
		y _ eachElement bottom ].
	x _ x + (bw * 3).
	labelTop _ y + bw.

	labels isEmpty 
		ifTrue: [
			label position: x @ labelTop.
			maxRight _ maxRight max: label right.
			maxHeight _ label height.
			labelBottom _ label bottom ]
		ifFalse: [
			maxHeight _ labels anyOne height.
			1 to: labels size do: [:i |
				arg _ arguments at: i.
				lb _ labels at: i.
				maxHeight _ maxHeight max: (arg height).

				lb position: x @ labelTop.
				x _ x + lb width + cw.
				arg position: x @ labelTop.
				x _ x + arg width + cw ].
			x _ x - cw.
			maxRight _ maxRight max: x.

			cntr _ labelTop + (maxHeight // 2).

			arguments do: [:each|
				each position: (each position x @ (cntr - (each height // 2))) ].
			labels do: [:each|
				each position: (each position x @ (cntr - (each height // 2))) ]].

	labelBottom _ labelTop + maxHeight.
	labelBottom _ labelBottom max: receiver bottom.

	self extent: ((maxRight - self left) @ (labelBottom - self top)) + bw2.



	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 20:51'!
fitForCascade

	| cw bw bw2 x arg lb maxHeight |
	cw _ self labelFont widthOf: $ .
	bw _ self borderWidth.
	bw2 _ bw * 2.

	x _ self left + bw2.

	labels isEmpty 
		ifTrue: [^super fit]
		ifFalse: [
			maxHeight _ labels anyOne height.
			1 to: labels size do: [:i |
				arg _ arguments at: i.
				lb _ labels at: i.
				maxHeight _ maxHeight max: (arg height).

				lb position: x @ (lb position y).
				x _ x + lb width + cw.
				arg position: x @ (arg position y).
				x _ x + arg width + cw ].
			self extent: (x - self position x - cw - bw2) @ maxHeight + (bw2 * 2).
			receiver position: (receiver position x @ (bounds center y - (receiver height // 2))).
			arguments do: [:each|
				each position: (each position x @ (bounds center y - (each height // 2))) ].
			labels do: [:each|
				each position: (each position x @ (bounds center y - (each height // 2))) ].
].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 01:06'!
fitInLine

	| h w cw bw bw2 x arg lb maxHeight |
	cw _ self labelFont widthOf: $ .
	bw _ self borderWidth.
	bw2 _ bw * 2.

	receiver position: (self left + bw2) @ (self top + bw2).
	x _ receiver right + cw.

	labels isEmpty 
		ifTrue: [
			h _ receiver height + (bw2 * 2).
			w _ receiver width + (label width) + (cw * 1.5) + (bw2 * 2).

			self width: w.
			self height: h.

			label position: x @ (bounds center y - (label height // 2)).

			self isLabelFirst ifTrue: [
				label position: (receiver position x) @ (label position y).
				receiver position: (label right + cw) @ (receiver position y) ]]
		ifFalse: [
			maxHeight _ receiver height.
			1 to: labels size do: [:i |
				arg _ arguments at: i.
				lb _ labels at: i.
				maxHeight _ maxHeight max: (arg height).

				lb position: x @ (lb position y).
				x _ x + lb width + cw.
				arg position: x @ (arg position y).
				x _ x + arg width + cw ].
			self extent: (x - self position x - cw - bw2) @ maxHeight + (bw2 * 2).
			receiver position: (receiver position x @ (bounds center y - (receiver height // 2))).
			arguments do: [:each|
				each position: (each position x @ (bounds center y - (each height // 2))) ].
			labels do: [:each|
				each position: (each position x @ (bounds center y - (each height // 2))) ].
].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 19:08'!
fitStacked

	| h w cw bw bw2 x y arg lb maxRight |
	cw _ self labelFont widthOf: $ .
	bw _ self borderWidth.
	bw2 _ bw * 2.

	receiver position: (self left + bw2) @ (self top + bw2).
	x _ receiver right + cw.
	y _ receiver bottom + bw.

	labels isEmpty 
		ifTrue: [
			h _ receiver height + (bw2 * 2).
			w _ receiver width + (label width) + (cw * 1.5) + (bw2 * 2).

			self width: w.
			self height: h.

			label position: x @ (bounds center y - (label height // 2)) ]
		ifFalse: [
			maxRight _ receiver right.
			1 to: labels size do: [:i |
				arg _ arguments at: i.
				lb _ labels at: i.

				lb position: receiver left + cw @ (y + ((arg height - lb height) // 2)).
				arg position: (lb right + cw) @ y.

				y _ y + arg height + bw.

				maxRight _ maxRight max: (arg right) ].

			self extent: ((maxRight - self left) + bw2) @ ((y - self top) + bw)].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 23:32'!
fullCopy
	|copy|
	copy _ self class new selector: selector.
	(#ifTrue:ifFalse: = selector) 
		ifTrue: [copy yesNo ].
	(#_ = selector) 
		ifTrue: [copy assign ].
	copy position: self position.
	(copy argumentCount < self argumentCount)
		ifTrue: [copy beBinary].
	^copy! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 18:39'!
hasCascade
	^cascade isEmpty not! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 18:14'!
initialize
	super initialize.
	labels _ OrderedCollection new.
	arguments _ OrderedCollection new.
	cascade _ OrderedCollection new.
	color _ Color orange darker.
	self addLabel.
	self addReceiver.
	self fit.! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 18:24'!
isBinary

	^(arguments size = 1) and: [
		selector asString last ~= ($:)]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/5/2009 00:51'!
isKeywords
	^arguments size > 0 & self isBinary not! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 01:58'!
isLabelFirst
	|firstWord disabled|
	disabled _ true. "change this to experiment with swapped unaries"
	disabled ifTrue: [^false].

	selector ifNil: [^false].
	firstWord _ (self label findTokens: ' ') first. 
		(#('is' 'as' 'has'	'wants') includes: firstWord)
			ifTrue: [ ^false].

	^arguments isEmpty & cascade isEmpty & receiver isHidden not! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:24'!
isStacked
	^((#(
		'isNil:'
		'ifNil:'
		'ifNotNil:'
		'ifTrue:'
		'ifFalse:'
		'ifTrue:ifFalse:'
		'ifFalse:ifTrue:'
		'select:'
		'detect:'
		'detect:ifNone:'
		'collect:'
		'reject:'
		'select:'
		'do:'
		'to:do:'
		'whileTrue:'
		'or:'
		'and:'
	)
	includes: selector) or: [
	(arguments select: [:arg | 
		arg contents isKindOf: BlockElementMorph])
			size > 0 ]) or: [ selector notNil and: [
				(selector findTokens: ':') size > 3] ]
! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 17:52'!
isUnary

	^arguments isEmpty! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 02:34'!
keywordsAndArgs
	| kw ws |
	kw _ selector keywords.
	(selector = ':=') ifTrue: [kw _ #('_')].
	ws _ WriteStream on: String new.
	1 to: kw size do: [:i|
		ws nextPutString: (kw at: i).
		(arguments size < i) ifFalse: [
			ws nextPutString: ' ', (arguments at: i) asSmalltalk, ' ' ]].
	^ws contents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:06'!
labelFont
	^self class labelFont! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 15:26'!
receiver
	^receiver contents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/20/2009 00:09'!
receiver: anElement
	receiver contents: anElement! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 23:30'!
removeCascadedElement: element

	cascade remove: element ifAbsent: [].
	self fit.
	element extractFromCascade.
	^self! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 22:53'!
rootForGrabOf: aMorph
	"Answer the root of the morph structure to be picked up when the given morph is grabbed."

	aMorph == self ifTrue: [^super rootForGrabOf: aMorph ].
	(aMorph isKindOf: self class) ifTrue: [^self].
	^super rootForGrabOf: aMorph
! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 23:38'!
selector: aString

	selector _ aString.
	self buildLabelsAndArgs.
	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 22:57'!
selector: aString arguments: anArray

	"for decompilation purposes only. Caution: this method assumes that the number of arguments matches the
	number of parameters required by the selector."

	| tokens lb arg |

	selector _ aString.
	label ifNotNil: [label delete. label _ nil].
	labels do: [:each| each delete ].
	arguments do: [:each| each delete ].
	labels _ OrderedCollection new.
	arguments _ OrderedCollection new.

	anArray isEmpty ifTrue: [
		self label: (self wordsFrom: selector).
		^self fit ].

	tokens _ selector findTokens: ':'.
	1 to: tokens size do: [:i |
		lb _ ((StringMorph 
				contents: (self wordsFrom: (tokens at: i)) 
				font: self labelFont) 
				color: self labelColor).
		labels add: lb.
		self addMorph: lb.
		arg _ ArgumentElementMorph new.
		arguments add: arg.
		self addMorph: arg.
		arg contents: (anArray at: i)].

	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 23:34'!
wantsDroppedMorph: aMorph event: evt

	(owner isKindOf: self class) ifTrue: [owner hasCascade ifTrue: [^false]].
	^(aMorph isKindOf: self class) and: [ (aMorph hasCascade not) & (aMorph receiver isNil) ]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 23:31'!
yesNo
	^self selector: #ifTrue:ifFalse: arguments: { BlockElementMorph new. BlockElementMorph new }.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MessageElementMorph class
	instanceVariableNames: ''!

!MessageElementMorph class methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:06'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 10! !
