NXTPeripheral subclass: #NXTSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-NXT Peripherals'!
!NXTSensor commentStamp: '<historical>' prior: 0!
Abstract base class for all NXT devices providing sensory input -- touch sensors, light sensors, ultrasonic sensors, etc.!


!NXTSensor methodsFor: 'accessing' stamp: 'CWB 12/17/2010 02:58'!
portName
"Returns the name of the port this sensor is on."

	^ 'SensorPort.S', portIndex asString.
! !

!NXTSensor methodsFor: 'accessing' stamp: 'CWB 12/17/2010 02:59'!
variableName
"The lejos variable that references this sensor."

	^ 'S', portIndex asString.
! !


!NXTSensor methodsFor: 'exporting' stamp: 'CWB 12/17/2010 10:39'!
emitInitializationCodeOn: aStream for: anExporter
"Outputs the code to initialize NXT peripherals."

"Output should look something like:
public static final TouchSensor S1 = new TouchSensor(SensorPort.S1);"

	| sensorClassName  |

	sensorClassName _ anExporter codeSpecFrom: concreteType asString.

	anExporter indentOn: aStream.
	aStream nextPutAll: 'public static final ', 
		sensorClassName, ' ', self variableName, ' = new ',
		sensorClassName, '(', self portName, ');'; cr.! !
