DialogBoxMorph subclass: #EnchantingFirmwareFlashDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-Dialogs'!

!EnchantingFirmwareFlashDialog methodsFor: 'as yet unclassified' stamp: 'CWB 5/16/2011 16:06'!
activity: currentAction

	done ifTrue: [^nil].
	self message: currentAction.
! !

!EnchantingFirmwareFlashDialog methodsFor: 'as yet unclassified' stamp: 'CWB 5/16/2011 16:27'!
activity: currentAction percentage: percentage

	| searchingPercent writingPercent verifyingPercent totalPercent |

	done ifTrue: [^nil].
	
	"Transcript show: (currentAction, ' --- ', percentage asString); cr."

	(percentage = -1) ifTrue: [
		"We have a status message.  Right now, we ignore almost all of them."
		
		"If everything completed successfully, respond to that effect."
		(currentAction = 'Restarting the device.') ifTrue: [ ^ self yes ].
		^ self.
	].

	self activity: currentAction.

	searchingPercent _ 0.
	writingPercent _ 0.
	verifyingPercent _ 0.

	(currentAction = 'Searching') 	ifTrue: 
		[ searchingPercent _ percentage ].
	(currentAction = 'Writing') 		ifTrue: 
		[ searchingPercent _ 100. writingPercent _ percentage ].
	(currentAction = 'Verifying') 	ifTrue: 
		[ searchingPercent _ 100. writingPercent _ 100.  verifyingPercent _ percentage ].

	"In one test, searchingPercent reached 40% in 13 seconds (and then the NXT was found).
	Writing took about 4 seconds and verifying took 3.5 seconds."
	totalPercent _ (searchingPercent * 0.6) + (writingPercent * 0.2) + (verifyingPercent * 0.2).
		
	self percentDone: totalPercent.
		
	self centerOnScreen.
	

	
	
! !

!EnchantingFirmwareFlashDialog methodsFor: 'as yet unclassified' stamp: 'CWB 3/10/2011 22:20'!
afterSilenceOf: milliseconds fail: failureMessage
"If the dialog does not hear back from the back end during this time interval, it displays 
the specified error message.  Note that it only check this at the start.  In the rare event
that the back end responds at all but does not respond to close the dialog, the user will
have to hit the 'cancel' button."

[ 
	Delay waitMSecs: milliseconds.  
	messageLineMorphs submorphs size = 0 ifTrue: [ self error: failureMessage ].		
] forkAt: Processor systemBackgroundPriority! !

!EnchantingFirmwareFlashDialog methodsFor: 'as yet unclassified' stamp: 'CWB 3/10/2011 22:20'!
error: error

	"Adds an error message to the dialog box"

	| s |

	"To Do: each sentance of the error message should
	be translated (if possible) and displayed independantly"

	done ifTrue: [^nil].

	s _ StringMorph 
		contents: error localized
		font: (ScratchFrameMorph getFont: #DialogBoxMessage).
	s color: Color red.
	self addMessageLine: s. 
	self withButtonsForYes: false 
		no: false
		okay: true 
		cancel: false.
	self centerOnScreen.
	

	
	
! !

!EnchantingFirmwareFlashDialog methodsFor: 'as yet unclassified' stamp: 'CWB 3/10/2011 22:34'!
initialize
	"Sets up the upload dialog box"

	super initialize.
	self title: 'Flashing Firmware';
		withButtonsForYes: false no: false okay: false cancel: true;
		message: ''.! !
