CommandBlockMorph subclass: #ReporterBlockDropTargetMorph
	instanceVariableNames: 'isBoolean feedbackMorph lambdaMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/12/2009 00:08'!
argument
	| am |
	am _ argMorphs first.
	(am isKindOf: ReporterBlockMorph) ifTrue: [ ^am ].
	(am isKindOf: BooleanArgMorph) ifTrue: [^nil ].
	^am labelMorph contents! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 23:46'!
argument: aMorphOrNumber
	(aMorphOrNumber isKindOf: ReporterBlockMorph)
		ifTrue: [^self replaceArgMorph: argMorphs first by: aMorphOrNumber ].
	argMorphs first stringExpression: aMorphOrNumber! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 13:23'!
drawOn: aCanvas

	aCanvas fillRectangle: self bounds color: color.
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 17:40'!
initialize
	super initialize.
	isBoolean _ false.
	self color: Color transparent! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/17/2008 10:29'!
isBoolean: aBoolean
	isBoolean _ aBoolean! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 23:43'!
label: aString
	|dropSpec|
	dropSpec _ ' %s'.
	isBoolean ifTrue: [dropSpec _ ' %b'].
	self commandSpec: aString, dropSpec! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 13:16'!
labelColor
	^Color gray: 0.3
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 03:12'!
layoutChanged
	| be |
	super layoutChanged.
	be _ self ownerThatIsA: BlockEditorFrameMorph.
	be ifNotNil: [ be adjustExtentToAnswerField ]
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/20/2009 22:42'!
replaceSubmorph: oldMorph by: newMorph
	| index itsPosition w |
	oldMorph stopStepping.
	itsPosition _ oldMorph referencePositionInWorld.
	index _ submorphs indexOf: oldMorph.
	(submorphs includes: newMorph) ifTrue: [ index _ index -1 ].
	oldMorph privateDelete.
	self privateAddMorph: newMorph atIndex: index.
	newMorph referencePositionInWorld: itsPosition.
	(w _ newMorph world) ifNotNil:
		[w startSteppingSubmorphsOf: newMorph].
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 23:40'!
rightButtonMenu

! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/17/2008 13:04'!
rootForGrabOf: aMorph
	"prevent myself from being extracted."

	^nil! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/19/2010 20:29'!
step
	"Give feedback about possible drop targets."

	| feedbackColor h b targetArg targetAssoc targetP targetBlock |
	feedbackMorph
		ifNil: [feedbackMorph _ BorderedMorph new borderWidth: 3]  "create feedback morph if necessary"
		ifNotNil: [feedbackMorph delete].  "remove old feedback"
	feedbackColor _ Color white.
	feedbackMorph useSquareCorners.

	lambdaMorph
		ifNotNil: [lambdaMorph delete. lambdaMorph _ nil].  "remove old lambda feedback"

	h _ World activeHand.
	"h toolType = 'CutTool' ifTrue: [^ self showDeleteFeedback]."

	(self bounds containsPoint: h position) ifFalse: [ ^ self].
	h submorphCount = 1 ifFalse: [^ self].
	(self uncoveredAt: h cursorPoint) ifFalse: [^ self].

	b _ h firstSubmorph.
	(b isKindOf: BlockMorph) ifFalse: [ ^ self].
	(b isKindOf: HatBlockMorph) ifTrue: [ ^ self ].

	b isReporter ifTrue: [ "reporter block"

		targetArg _ (self allMorphs) detect: [:m | (m isKindOf: ArgMorph) and: [m bounds containsPoint: h position]] ifNone: [nil].
		targetArg ifNil: [

			(targetArg _ self topArgMorphAt: b bounds exclude: nil) ifNil: [^ self]].

		(targetArg acceptsTypeOf: b) ifFalse: [ ^ self].
		feedbackMorph
			bounds: (targetArg bounds expandBy: 5);
			color: (feedbackColor alpha: 0.4);
			borderColor: feedbackColor;
			useRoundedCorners.

		(targetArg isKindOf: OSlotMorph) ifTrue: [
			feedbackMorph
				bounds: (targetArg bounds expandBy: 8)].

		((targetArg isKindOf: SpecialArgMorph) 
		and: [(#(reporterslot booleanslot) includes: targetArg type)
		and: [(targetArg owner isKindOf: ReporterScriptBlockMorph) not]]) ifTrue: [
			feedbackMorph
				color: (feedbackColor);
				bounds: (targetArg bounds insetBy: 3).
			lambdaMorph _ ImageMorph new form: ((b imageForm outlineWidth: 3 color: Color gray depth: 8) 
														withOutlineColor: Color lightGray lighter width: 1)].
	
		lambdaMorph ifNotNil: [
			lambdaMorph position: b position - 4.
			h addMorphBack: lambdaMorph].

		h addMorph: feedbackMorph].




	"non-reporter (i.e. command block)"
	targetAssoc _ b closestAttachTargetIn: self.
	targetAssoc ifNil: [
		(b bottomBlock isKindOf: CBlockMorph) ifFalse: [
			targetAssoc _ b bottomBlock closestAttachTargetIn: self.
			targetAssoc ifNotNil:[
				(targetAssoc value owner isKindOf: BlockMorph) ifTrue:[
					targetAssoc _ nil]]]].
	targetAssoc ifNil: [^ self].

	targetP _ targetAssoc key.
	targetBlock _ targetAssoc value.
	feedbackMorph borderColor: feedbackColor; color: feedbackColor.

	"subtract the attachment point x from the width so that the feedback in CBlock won't stick out"
	ScratchTranslator isRTL
		ifTrue: [feedbackMorph extent: (targetP x - targetBlock left)@5.
			h addMorphFront: (feedbackMorph position: targetP - (feedbackMorph width@0))]
		ifFalse: [feedbackMorph extent: (targetBlock right - targetP x)@5.
			h addMorphFront: (feedbackMorph position: targetP)].! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/12/2009 10:11'!
stepTime
	"Answer the desired time between steps in milliseconds. This default implementation requests that the 'step' method be called once every second."

	^0
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/15/2010 21:18'!
topArgMorphAt: aRectangle exclude: aMorph
	"Give feedback about possible drop targets."

	| stack argM area |
	"find the top block or stack under the given point, excluding the given morph"

	area _ [:morph |
			| space |
			space _ morph bounds.
			({CSlotMorph. OSlotMorph} includes: morph class)
				ifTrue: [space _ morph bounds expandBy: 5].
			((morph isKindOf: SpecialArgMorph) and: [
				#(reporterslot booleanslot) includes: morph type])
					ifTrue: [space _ morph bounds insetBy: 8].
			space].

	stack _ submorphs
		detect: [:m | (m ~~ aMorph) and: [(m isKindOf: BlockMorph) and: [m fullBounds intersects: aRectangle]]]
		ifNone: [ ^ self argumentAt: 1].

	stack allMorphsDo: [:b |
		((b isKindOf: CommandBlockMorph) and:
		 [(b isKindOf: HatBlockMorph) not]) ifTrue: [
			1 to: b argumentCount do: [:i |
				argM _ b argumentAt: i.

				(argM isKindOf: MultiArgMorph) ifTrue: [
					argM elements do: [:elmt |
						((area value: elmt) intersects: aRectangle) ifTrue: [
							^elmt]]].

				(((area value: argM) intersects: aRectangle) and:
				 [argM acceptsDroppedReporters])
					ifTrue: [^ argM]]]].

	(stack isKindOf: ReporterBlockMorph "ReporterScriptBlockMorph")
		ifTrue: [^ stack]
		ifFalse: [^ nil].
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/15/2010 20:59'!
uncoveredAt: aPoint
	"Return true if the receiver is not covered by any submorphs at the given point."

	| w morphsAbove be  |
	(w _ self world) ifNil: [^ true].

	morphsAbove _ w morphsAt: aPoint.
	(morphsAbove size = 0) ifTrue: [^ true ].

	be _ self ownerThatIsA: DialogBoxMorph.

	morphsAbove do: [:m | ((m isKindOf: DialogBoxMorph) and: [m ~= be])
		ifTrue: [^ false ]].

	^ true! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/28/2010 02:13'!
wantsDroppedMorph: aMorph event: evt
	| topArg |

	(aMorph isKindOf: CommandBlockMorph) ifFalse: [^false ].
	topArg _ self topArgMorphAt: aMorph bounds exclude: nil.
	topArg ifNil: [^ false].
	^ topArg acceptsTypeOf: aMorph 
! !


!ReporterBlockDropTargetMorph methodsFor: 'Enchanting' stamp: 'JM 10/13/2011 12:01'!
previousBlock

	"delete me"

	"a bit tricky - need to find the last block in the main stack, which will represent the block immediately before this one. Used for finding variable and argument names"
	
	| frame proc stack |
	frame _ self ownerThatIsA: BlockEditorFrameMorph.
	frame ifNil: [ ^ nil ].

	Transcript show: 'Found frame'.

	proc _ frame submorphs select: [ :sub | sub isKindOf: ProcedureHatBlockMorph ].
	proc size = 1 ifFalse: [ ^ nil ].
	proc _ proc at: 1.

	stack _ proc submorphs reject: [ :sub | ( sub isKindOf: CustomCommandBlockMorph) | ( sub isKindOf: CustomReporterBlockMorph ) ].

	stack size = 1 ifFalse: [ ^ nil ].

	true whileTrue: [
		stack nextBlock ifNotNil: [ stack _ stack nextBlock ]
			ifNil: [ ^ stack ].
	]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ReporterBlockDropTargetMorph class
	instanceVariableNames: ''!

!ReporterBlockDropTargetMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/12/2009 00:31'!
booleanLabelled: aString argument: aMorphOrNumber
	 | m |
	m _ self new isBoolean: true; label: aString; color: Color  lightGray twiceLighter twiceLighter.
	(aMorphOrNumber isKindOf: ReporterBlockMorph) ifTrue: [m argument: aMorphOrNumber ].
	^m! !

!ReporterBlockDropTargetMorph class methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 13:37'!
labelled: aString
	^self new label: aString! !

!ReporterBlockDropTargetMorph class methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 13:49'!
labelled: aString argument: aMorphOrNumber
	^self new label: aString; argument: aMorphOrNumber! !
